package com.adc.da.util.persistence.entity;

import javax.persistence.*;
import java.util.List;

@MappedSuperclass
public abstract class TreeEntity<T extends TreeEntity> {

    protected String id;
    protected String name;
    protected String parentId; // 所有父级编号
    protected String parentIds; // 所有父级编号
    protected T parent;    // 父级编号
    protected List<T> childList;
    protected Integer delFlag;

    @Id
    @Column(name = "id", columnDefinition="varchar2(255 char)", nullable = false)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Basic
    @Column(name = "parent_id", columnDefinition="varchar2(255 char)")
    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    @Basic
    @Column(name = "parent_ids", columnDefinition="varchar2(255 char)")
    public String getParentIds() {
        return parentIds;
    }

    public void setParentIds(String parentIds) {
        this.parentIds = parentIds;
    }

    @Basic
    @Column(name = "name", columnDefinition="varchar2(255 char)")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Transient
    public List<T> getChildList() {
        return childList;
    }

    public void setChildList(List<T> childList) {
        this.childList = childList;
    }

    @Transient
    public T getParent() {
        return parent;
    }

    public void setParent(T parent) {
        this.parent = parent;
    }

    @Basic
    @Column(name = "del_flag", columnDefinition = "number(10)")
    public Integer getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(Integer delFlag) {
        this.delFlag = delFlag;
    }

}
