package com.adc.da.util.utils;

import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.lang.reflect.Method;
import java.net.URL;
import java.net.URLConnection;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.FutureTask;
import java.util.concurrent.TimeUnit;

import javax.imageio.ImageIO;

import org.apache.commons.io.FileUtils;
import org.apache.log4j.Logger;
import org.openqa.selenium.By;
import org.openqa.selenium.OutputType;
import org.openqa.selenium.TakesScreenshot;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;

import com.google.gson.Gson;

public class ChromeDriverUtil {
    
	private static Logger logger = Logger.getLogger(ChromeDriverUtil.class);
   
    /**
    * @Author:adc_liuyang  
    * @Date: 2019年1月14日 下午2:11:13
    * @Title: getVerifyCode
    * @Description: 获取验证码图片,保存到本地并解析
    * @param webdriver
    * @param imageId
    * @throws IOException
    * @return: String
    * @throws InterruptedException 
    */
    @SuppressWarnings("unchecked")
	public static  Map<String,String> getVerifyCode(WebDriver webdriver,String imageId,String typeId) throws IOException, InterruptedException {
    	WebElement ele = webdriver.findElement(By.xpath(".//img[@id='"+ imageId + "']")); 
        Thread.sleep(5000);
        File screenshot = ((TakesScreenshot) webdriver).getScreenshotAs(OutputType.FILE);
        System.out.println(screenshot.getAbsolutePath());
        BufferedImage fullImg = ImageIO.read(screenshot); // 读取截图
        // 得到页面元素
        org.openqa.selenium.Point point = ele.getLocation();
        // 得到长、宽
        int eleWidth = ele.getSize().getWidth();
        int eleHeight = ele.getSize().getHeight();

        BufferedImage eleScreenshot = fullImg.getSubimage(point.getX(), point.getY(), eleWidth, eleHeight);
        ImageIO.write(eleScreenshot, "png", screenshot);
        // copy 把图片放对应的生成目录下
        File rootCertECloudPath = new File("D:/CertECloud/");
        if (!rootCertECloudPath.exists()) {
            rootCertECloudPath.mkdir();
        }
        long date = System.currentTimeMillis();
        // 添加随机数命名验证码照片的名字
        File screenshotLocation = new File("D:/CertECloud/" + date + ".jpg");
        FileUtils.copyFile(screenshot, screenshotLocation);
        // 调用识别图片API方法
        String verifyCode = "";
        //若快替换成超级鹰  update by adc_liuyang 20190517
//        String imageResult = ChaoJiYing.PostPic("adczhang", "zhpasss", "96001",
//        		typeId, "4", screenshotLocation.getAbsolutePath());
        Gson gson = new Gson();
        String imageResult = "";
        Map<String, String> map = new HashMap<String, String>();
        map = gson.fromJson(imageResult, map.getClass());
        if(map.get("err_str").equals("OK")){
        	verifyCode = map.get("pic_str") == null?"":map.get("pic_str").toString();
        }
        map.put("verifyCode", verifyCode);
        map.put("pictureId", map.get("pic_id") == null?"":map.get("pic_id").toString());
        //String imageResult = createByPost("ADCliuyang", "wdsr198982", typeId, "90", "1","b40ffbee5c1cf4e38028c197eb2fc751", screenshotLocation.getAbsolutePath());
        // 返回字符串格式为<?xml
        // version="1.0"?><Root><Result>答案</Result><Id>题目Id(报错使用)</Id></Root>
        /*
        if (imageResult.indexOf("<Result>") > -1) {
            Pattern p = Pattern.compile("<Result>(.*)</Result>");
            Matcher m = p.matcher(imageResult);
            while (m.find()) {
                verifyCode = m.group(1);
            }
        }*/
        return map;
    }
    
    @SuppressWarnings("unchecked")
	public static  Map<String,String> getSlideVerifyCode(WebDriver webdriver,String imageId,String typeId) throws Exception {
    	WebElement ele = webdriver.findElement(By.xpath(".//img[@class='"+ imageId + "']")); 
    	String src = ele.getAttribute("src");
    	//将图片下载到本地,并返回绝对路径
    	String realPicturePath = download(src);
        // 调用识别图片API方法
        String verifyCode = "";
        //若快替换成超级鹰  update by adc_liuyang 20190517
        String imageResult ="";
//        ChaoJiYing.PostPic("adczhang", "zhpasss", "96001",
//        		typeId, "0", realPicturePath);
        Gson gson = new Gson();
        Map<String, String> map = new HashMap<String, String>();
        map = gson.fromJson(imageResult, map.getClass());
        if(map.get("err_str").equals("OK")){
        	verifyCode = map.get("pic_str") == null?"":map.get("pic_str").toString();
        }
        map.put("verifyCode", verifyCode);
        map.put("pictureId", map.get("pic_id") == null?"":map.get("pic_id").toString());
        //String imageResult = createByPost("ADCliuyang", "wdsr198982", typeId, "90", "1","b40ffbee5c1cf4e38028c197eb2fc751", screenshotLocation.getAbsolutePath());
        // 返回字符串格式为<?xml
        // version="1.0"?><Root><Result>答案</Result><Id>题目Id(报错使用)</Id></Root>
        /*
        if (imageResult.indexOf("<Result>") > -1) {
            Pattern p = Pattern.compile("<Result>(.*)</Result>");
            Matcher m = p.matcher(imageResult);
            while (m.find()) {
                verifyCode = m.group(1);
            }
        }*/
        return map;
    }
    
    /**
    * @Description: 将在线图片下载并保存至本地文件夹中
    * @param urlString
    * @throws Exception
    * @Title: download
    * @return void
     */
    public static String download(String urlString) throws Exception {
        // 构造URL
        URL url = new URL(urlString);
        // 打开连接
        URLConnection con = url.openConnection();
        // 输入流
        InputStream is = con.getInputStream();
        // 1K的数据缓冲
        byte[] bs = new byte[1024];
        // 读取到的数据长度
        int len;
        // 输出的文件流
        long date = System.currentTimeMillis();
        String filename = "D:/CertECloud/" + date + ".jpg";  //下载路径及下载图片名称
        File file = new File(filename);
        FileOutputStream os = new FileOutputStream(file, true);
        // 开始读取
        while ((len = is.read(bs)) != -1) {
            os.write(bs, 0, len);
        }
        // 完毕，关闭所有链接
        os.close();
        is.close();
        return file.getAbsolutePath();
    }
    
   

    /**
    * @Author:adc_liuyang  
    * @Date: 2019年1月14日 下午2:17:56
    * @Title: createByPost
    * @Description: 若开识别验证码API方法
    * @param username
    * @param password
    * @param typeid
    * @param timeout
    * @param softid
    * @param softkey
    * @param filePath
    * @return: String
    */
    private static String createByPost(String username, String pwd, String typeid, String timeout, String softid,
            String softkey, String filePath) {
        String result = "";
        String param = String.format("username=%s&password=%s&typeid=%s&timeout=%s&softid=%s&softkey=%s", username,
                pwd, typeid, timeout, softid, softkey);
        FileInputStream fis = null;
        try {
            File f = new File(filePath);
            if (null != f) {
                int size = (int) f.length();
                byte[] data = new byte[size];
                fis = new FileInputStream(f);
                fis.read(data, 0, size);
                if (data.length > 0){
//                	result = RuoKuai.httpPostImage("http://api.ruokuai.com/create.xml", param, data);
                }                   
            }
        } catch (Exception e) {
            result = "未知问题";
        }finally{
        	 if(null != fis){
                 try {
                     fis.close();
                 } catch (IOException ex) {
                 	logger.error(ex.getMessage());
                 }
             }
        }
        return result;
    }
    
    @SuppressWarnings("unchecked")
	public static  Map<String,String> getSlideVerifyCodeByimage(WebDriver webdriver,String imageId1,String imageId2) throws Exception {
    	WebElement ele1 = webdriver.findElement(By.xpath(".//img[@class='"+ imageId1 + "']")); 
    	WebElement ele2 = webdriver.findElement(By.xpath(".//img[@class='"+ imageId2 + "']")); 
    	String src1 = ele1.getAttribute("src");
    	String src2 = ele2.getAttribute("src");
    	//将图片下载到本地,并返回绝对路径
    	/*String realPath1 = download(src1);
    	String realPath2 = download(src2);
*/
    	Runtime r = Runtime.getRuntime();
        System.out.println("开始执行。。。。。。。。。。");
        String command = " python D:\\imgePython\\moban.py -src "
        		+ src1 + " -tem " + src2
        		+ " -txtname D:\\imgePython\\4.txt" ;
        System.out.println("cmd.exe /C "+command);
//        String[] cmd = new String[]{"/bin/sh", "-c", command};
        String[] cmd = new String[]{"cmd.exe", "/C", command};
        Process p = null;
        try {
//            p = r.exec(cmd); 
//            p = r.exec("cmd /k start   "+command);
            Runtime.getRuntime().exec("cmd.exe /c start "+command);  
//            Runtime.getRuntime().exec("cmd.exe /C start "+command);
            System.out.println("指令执行成功！！！");
            /*int i = p.waitFor();
            if (i != 0) {
                throw new IOException("执行图像识别失败");
            }*/
        } catch (IOException e) {
            e.printStackTrace();
        }/* catch (InterruptedException e) {
            e.printStackTrace();
        }*/
        System.out.println("执行结束。。。。。。。。。。");
        String dst = "D:\\imgePython\\4.txt";
        // 获取识别之后结果文件内容
        System.out.println("开始读取。。。。。。。。。。");
        String txt = readTxt(dst);
        System.out.println("D:\\imgePython\\4.txt----"+txt);
        Map<String, String> map = new HashMap<String, String>();
        map.put("length", txt);
        return map;
    }
    
      
    
    /**
    * @Author:adc_liuyang  
    * @Date: 2019年1月22日 下午2:35:57
    * @Title: callMethod
    * @Description: 控制爬虫方法超时
    * @param target 调用方法的当前对象
    * @param methodName 方法名称
    * @param parameterTypes 调用方法的参数类型
    * @param params 参数  可以传递多个参数
    * @return: Object
    * @throws:
    */
    public static Object callMethod(final Object target , final String methodName ,final Class<?>[] parameterTypes,final Object[]params){
    	ExecutorService executorService = Executors.newSingleThreadExecutor();  
        FutureTask<String> future = new FutureTask<String>(new Callable<String>() {       
            @Override
			public String call() throws Exception {
            	String value = null;
            	try {
					Method method = null ;
					method = target.getClass().getDeclaredMethod(methodName , parameterTypes ) ;  
					Object returnValue = method.invoke(target, params); 
					value = returnValue != null ? returnValue.toString() : null ;
				} catch (Exception e) {
					logger.error(e.getMessage());
				}
                return value;
            }  
        });  
          
        executorService.execute(future);  
        String result = null;  
        try{
        	/**获取方法返回值 并设定方法执行的时间为90秒*/
            result = future.get(90 , TimeUnit.SECONDS );  
            
        }catch (Exception e) {
            future.cancel(true);  
            throw new RuntimeException("查询失败" , e );
        }
        executorService.shutdownNow(); 
        return result ;
	}
    
    
    public static String readTxt(String filePath) {
        System.out.println("txt文件路径" + filePath);
        StringBuilder str = new StringBuilder();
        File file = new File(filePath);
        try {
            if (file.isFile() && file.exists()) {
                System.out.println("文件存在");
                InputStreamReader isr = new InputStreamReader(new FileInputStream(file), "utf-8");
                System.out.println("InputStreamReader OK!");
                BufferedReader br = new BufferedReader(isr);
                System.out.println("BufferedReader OK!");
                String lineTxt = null;
                while ((lineTxt = br.readLine()) != null) {
                    str.append(lineTxt);
                }
                br.close();
            } else {
                throw new IOException("获取识别结果失败");
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return str.toString();
    }
}
